from agent.models import UserAgentStorage


class UANotingMiddleware:
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        response = self.get_response(request)
        if request.user.is_authenticated and request.headers.get('User-Agent'):
            user_agent = request.headers['User-Agent']
            try:
                ua = UserAgentStorage.objects.get(user=request.user)
                ua.ua = user_agent
            except UserAgentStorage.DoesNotExist:
                ua = UserAgentStorage(user=request.user, ua=user_agent)
            ua.save()

        return response
